#!/usr/bin/perl

BEGIN { $APP_PATH=$0; $APP_PATH=~s/(\/*)[^\/]+$/$1/g; push @INC,$APP_PATH; }

# @ ----------------------------------------------------------------------------------------------------------
# @ This code is (c) 1999 Alexandre Aufrere and NikoSoft.
# @ Published under NPL rights, meaning you have the right
# @ to use and modify this code freely, provided it 
# @ remains available and free. Any modified code should be
# @ submitted to Nikopol Software Corp. or Alexandre Aufrere.
# @ This code is protected by the French laws on Copyright.
# @ Please note that there it comes with NO WARRANTY of any kind,
# @ and especially for any damagbe it could cause to your computer
# @ or network.
# @ Using this code means you agree to this license agreement.
# @ Further information at http://www.nikosoft.net/
# @ ----------------------------------------------------------------------------------------------------------
# @ 
# @ Project		NS WebMail
# @ 
# @ Filename		getmsg.pl
# @ 
# @ Description	view messages using POP protocol.
# @ 
# @ Version		0.6
# @ 
# @ ----------------------------------------------------------------------------------------------------------

use strict;
use common;
use Mail::POP3Client;
use MIME::Parser;
use configwm;
use CGI;

#obtain the FORM information that has been passed by using
#the param() method of the cgi object.
my $query=new CGI;
my $nswmc=new common;
my $loginname =  $query->param("loginname");
my $pkey = $query->cookie(-name=>'PKEY');
my $password =   $query->param("password"); # encrypted password !!!
my $POPserver =  $query->param("POPserver");
my $msgid =      $query->param("id");
my $cache     =  $query->param("cache");

my $browser = $ENV{'HTTP_USER_AGENT'};

$|=1;
#clear and init the $body variable.
my $body ="";

#create a POP connection using the POP3client module by
#creating an object called $pop of type POP3Client. See
#POP3Client.pm documentation.
my $pop = new Mail::POP3Client( USER=>$loginname,
			PASSWORD=> $nswmc->decryptit($password,$pkey),
			HOST=>$POPserver,
			AUTH_MODE=>$conf::POPauth,PORT=>$conf::POPport,
			TIMEOUT=>$conf::pop3_timeout
			);

my $MessageCount = $pop->Count;

print "Expires: -1d\n";
print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>NSC WebMail";
print "</TITLE>";
print "<META HTTP-EQUIV='Pragma' CONTENT='no-cache'>"; 
print "</HEAD>";
print "<BODY BGCOLOR='FFFFFF'>";

$nswmc->startmenu($loginname,$POPserver,$cache,$password) if ($conf::noframes);

my $FLUSH_IE = " " x 1000 . "\n";
print $FLUSH_IE;

my $message="";
foreach ($pop->HeadAndBody($msgid)) {
	$message.=$_."\n";	
}

print "ouch !" if ($MessageCount==-1);

my $parser = new MIME::Parser;
$parser->output_dir($conf::temppath);
$parser->output_prefix("msg$msgid");
my $entity = $parser->parse_data($message);

# Get the head, a MIME::Head:
my $head = $entity->head;
$head->unfold;
$head->decode();
my $from=$head->get('from');
$from=~ s/"//g;
my $replyto=$head->get('reply-to');
$replyto=~ s/"//g;
my $to=$head->get('To');
$to=~ s/"//g;
my $cc=$head->get('cc');
$cc=~ s/"//g;
my $date=$head->get('date');
my $sub=$head->get('subject');

my $attachref=[];
my $messagestored=$nswmc->decodemail($entity,$attachref,1);
my @attach=@{$attachref};
print "<center><TABLE border=0><TR>";

my $msg_prev;
my $msg_next;

$msg_prev=$msg_next=$msgid;
if ($msgid > 1) { $msg_prev = $msgid-1;  }
if ($msgid < $MessageCount) { $msg_next = $msgid+1; }

if ($msg_prev != $msgid) {
	print "<TD><FORM METHOD='POST'  ACTION='".$conf::CGI_PATH_NSWM."getmsg.pl' NAME='lire$msg_prev'>\n";
	print "<INPUT TYPE='submit'			VALUE='&lt;'>\n";
	print "<INPUT TYPE='hidden' NAME='id'		VALUE=\"$msg_prev\"	>\n";
	print "<INPUT TYPE='hidden' NAME='loginname'	VALUE=\"$loginname\"   >\n";
	print "<INPUT TYPE='hidden' NAME='password'	VALUE=\"$password\"    >\n";
	print "<INPUT TYPE='hidden' NAME='POPserver'	VALUE=\"$POPserver\"   >\n";
	print "<INPUT TYPE='hidden' NAME='cache'	VALUE=$cache    >\n";
	print "</FORM></TD>";
}

print "<TD valign=center><font size='+1'># $msgid</font></TD>";

if ($msg_next != $msgid) {
	print "<TD><FORM METHOD='POST'  ACTION='".$conf::CGI_PATH_NSWM."getmsg.pl' NAME='lire$msg_next'>\n";
	print "<INPUT TYPE='submit'			VALUE='&gt;'>\n";
	print "<INPUT TYPE='hidden' NAME='id'		VALUE=\"$msg_next\"	>\n";
	print "<INPUT TYPE='hidden' NAME='loginname'	VALUE=\"$loginname\"   >\n";
	print "<INPUT TYPE='hidden' NAME='password'	VALUE=\"$password\"    >\n";
	print "<INPUT TYPE='hidden' NAME='POPserver'	VALUE=\"$POPserver\"   >\n";
	print "<INPUT TYPE='hidden' NAME='cache'	VALUE=$cache    >\n";
	print "</FORM></TD>";
}


# Now create a button which will enable a user to generate a reply.
# As usual, the button is loaded with hidden values to permit a message
# to actually be sent at a later time.

if ($replyto == '') { $replyto = $from;  }

print "<TD ALIGN=CENTER>\n";
print "<FORM METHOD='POST' ACTION='".$conf::CGI_PATH_NSWM."sendform.pl' name=reMailForm>\n";
print "<INPUT TYPE='submit'                       VALUE='$conf::answertext'>\n";
print "<INPUT TYPE='hidden'  NAME='loginname'     VALUE=\"$loginname\">\n";
print "<INPUT TYPE='hidden'  NAME='password'      VALUE=\"$password\">\n";
print "<INPUT TYPE='hidden'  NAME='POPserver'     VALUE=\"$POPserver\">\n";
print "<INPUT TYPE='hidden'  NAME='to'            VALUE=\"",he($replyto),"\">\n";
print "<INPUT TYPE='hidden'  NAME=\"subject\"       VALUE=\"",he("Re: $sub"),"\">\n";
print "<INPUT TYPE='hidden'  NAME=\"msgid\"          VALUE=\"$msgid\">\n";
print "<INPUT TYPE='hidden'  NAME='cache'         VALUE=$cache>\n";
print "</FORM></TD>\n";

print "<TD ALIGN=CENTER>\n";
print "<FORM METHOD='POST' ACTION='".$conf::CGI_PATH_NSWM."sendform.pl' name=fwdMailForm>\n";
print "<INPUT TYPE='submit'                       VALUE='$conf::fwdtext'>\n";
print "<INPUT TYPE='hidden'  NAME='loginname'     VALUE=\"$loginname\">\n";
print "<INPUT TYPE='hidden'  NAME='password'      VALUE=\"$password\">\n";
print "<INPUT TYPE='hidden'  NAME='POPserver'     VALUE=\"$POPserver\">\n";
print "<INPUT TYPE='hidden'  NAME='to'            VALUE=\"\">\n";
print "<INPUT TYPE='hidden'  NAME=\"subject\"       VALUE=\"",he("Fw: $sub"),"\">\n";
print "<INPUT TYPE='hidden'  NAME=\"msgid\"          VALUE=\"$msgid\">\n";
print "<INPUT TYPE='hidden'  NAME='cache'         VALUE=$cache>\n";
print "</FORM></TD>\n";

#for each message header, also provide a FORM button to
#delete using inbox.pl As above, pass in the needed vars
#using hidden types.
print "<TD ALIGN=CENTER>\n";
print "<FORM METHOD='POST' ACTION='".$conf::CGI_PATH_NSWM."inbox.pl'>\n";
print "<INPUT TYPE='submit'                   VALUE='$conf::deletetext' OnClick=\"return confirm('$conf::deleteconfirmtext');\"  >\n";
print "<INPUT TYPE='hidden' NAME='loginname'  VALUE=\"$loginname\" >\n";
print "<INPUT TYPE='hidden' NAME='password'   VALUE=\"$password\"  >\n";
print "<INPUT TYPE='hidden' NAME='POPserver'  VALUE=\"$POPserver\" >\n";
print "<INPUT TYPE='hidden' NAME='deleteMsg'  VALUE=\"$msgid\"         >\n";
print "<INPUT TYPE='hidden' NAME='cache'      VALUE=$cache  >\n";

print "</FORM></TD></TR></TABLE>";

$from=he($from);
$to=he($to);
$cc=he($cc);

print "</center><table border=0 width=100%><tr bgcolor=$conf::lightbgcolor><td><font face=arial><ul>";

print "$conf::totext: $to <br>\n";
print "Cc: $cc <br>\n" if ($cc ne"");
print "$conf::fromtext: <b>$from</b><br>\n";
print "$conf::subjecttext: <b>$sub</b>  <br>\n";
$date=~ s/.*\,(.*)\+.*/$1/;
print "$conf::datetext: $date <br>\n";
my $attach;
if (scalar(@attach)>0) {
	print "$conf::attachtext:<ol>";
	foreach $attach (@attach) {
		my $file=$attach; $file=~s/$conf::tempurl\///;
		my $size = (stat("$conf::temppath/$file"))[7];
		print "<li><a href=\"$attach\" target=_blank>$file</a> ",int(($size+512)/1024)."k\n";
	}
	print "</ol>";
}

print "</ul></font></td></tr></table>";

print "<br>";

print $messagestored;

#close the POP connection using the close() method
$pop->Close();

$nswmc->stopmenu() if ($conf::noframes);

undef($pkey);
undef($msgid);
undef(@attach);
undef($parser);
undef($entity);
undef($pop);
undef($head);
undef($from);
undef($sub);
undef($nswmc);

#send the ending html code (/body and /head tags)
print "</BODY></HTML>\n";
exit;


#-----------------------------SUBROUTINES------------------------

sub decodeHexChars {
	my ($text)=@_;
	$text =~ s/=([0-9]{2})/chr(hex($1))/eg;
	return $text;
}

sub he {	# HtmlEscape
	my ($line,$out);
	foreach $line (@_) {
		$line=~s/</&lt;/g;
		$line=~s/>/&gt;/g;
		$line=~s/"/&quot;/g;
		$out.=$line;
	}
	return $out;
}

