#!/usr/bin/perl

BEGIN { $APP_PATH=$0; $APP_PATH=~s/(\/*)[^\/]+$/$1/g; push @INC,$APP_PATH; }

# @ ----------------------------------------------------------------------------------------------------------
# @ This code is (c) 1999 Alexandre Aufrere and NikoSoft.
# @ Published under NPL rights, meaning you have the right
# @ to use and modify this code freely, provided it 
# @ remains available and free. Any modified code should be
# @ submitted to Nikopol Software Corp. or Alexandre Aufrere.
# @ This code is protected by the French laws on Copyright.
# @ Please note that there it comes with NO WARRANTY of any kind,
# @ and especially for any damagbe it could cause to your computer
# @ or network.
# @ Using this code means you agree to this license agreement.
# @ Further information at http://www.nikosoft.net/
# @ ----------------------------------------------------------------------------------------------------------
# @ 
# @ Project		NS WebMail
# @ 
# @ Filename		inbox.pl
# @ 
# @ Description	inbox manager for NS WebMail
# @ 
# @ Version		1.0
# @ 
# @ ----------------------------------------------------------------------------------------------------------

use strict;
use common;
use Mail::POP3Client;
use configwm;
use CGI;
use URI::Escape;

#use the $cgi object method param() to
#acquire the FORM variables passed by
#the client browser.
my $query=new CGI;
my $nswmc=new common;
my $loginname = $query->param("loginname");
my $pkey = $query->cookie(-name=>'PKEY');
my $password  = $query->param("password");
my $POPserver = $query->param("POPserver");
my $lastMsg   = $query->param("lastMsg");
my $deleteMsg = $query->param("deleteMsg");
my $cache     = $query->param("cache");

# in case of noframes use, we have to make a new PKEY
if (((!$pkey)||($pkey=~ m/000/))&&($conf::noframes)) {
	$pkey = join ('', ('.', '!', 0..9, 'A'..'Z', 'a'..'z')[rand 64, rand 64, rand 64, rand 64, rand 64, rand 64]);
} else {
	$password  = $nswmc->decryptit($password,$pkey);
}


$|=1;
#if deleteMsg is not null, then this script has been called by the
#Delete Message button.  We will open a POP client object, delete
#the indicated message, then close the POP object to actually force
#the POP server to make the deletion.  The rest of the script will
#then play out and re-open the POP object.  By closing and reopening
#we will obtain an updated count that correctly does not include the
#recently deleted message.

if ($deleteMsg) {
	my $pop = new Mail::POP3Client( USER=>$loginname, 
			PASSWORD=>$password, 
			HOST=>$POPserver,
			AUTH_MODE=>$conf::POPauth,PORT=>$conf::POPport,
			TIMEOUT=>$conf::pop3_timeout
			);
	$pop->Delete($deleteMsg);
	$pop->Close();
	$deleteMsg = "";
	$pop = "";
	sleep(1);	# Gives the POP time to close and be ready for another
				# open attempt.
	}

# optionnaly, we re-set the cookie
my $cookie = $query->cookie(-name => "PKEY",
                            -value => $pkey,
                            -domain => $conf::cookiedomain,
                            -path => $conf::cookiepath
                            );

print $query->header(-expires => "-1d", -cookie => $cookie) if (defined($conf::cookiedomain));
print $query->header(-expires => "-1d") if (!defined($conf::cookiedomain));

#Begin production of HTML code.
print "<HTML><HEAD><TITLE>NS WM Message Retrieval</TITLE>";

print "<META HTTP-EQUIV='Pragma' CONTENT='no-cache'>"; 
print "</HEAD>\n<BODY BGCOLOR='#FFFFFF' LINK=$conf::linkcolor VLINK=$conf::linkcolor ALINK=$conf::linkcolor>";

if ($conf::noframes) {
	my $cpassword=$nswmc->cryptit($password,$pkey);
	$nswmc->startmenu($loginname,$POPserver,$cache,$cpassword);
}

print "<center>\n";

#Create a (possibly new) POP connection with the POP3Client object.
my $pop = new Mail::POP3Client( USER=>$loginname, 
			PASSWORD=>$password, 
			HOST=>$POPserver,
			AUTH_MODE=>$conf::POPauth,PORT=>$conf::POPport,
			TIMEOUT=>$conf::pop3_timeout
			);

#How many messages are there in the inbox provided by the $pop object?
my $MessageCount = $pop->Count;

#gather additional size info
my @MessageSize = $pop->ListArray;

print "<table><tr><td>";
#if $pop->count is -1, then the POP connection failed.
if ($MessageCount == -1) {
	print "</table><font size=+1>$POPserver: $loginname, $conf::incorrectlogin";
	print "</body></html>";
	exit;
	}
#if $pop->count is 0, there are no messages in the POP account		
elsif ($MessageCount == 0) {
        print "<b> $conf::nomailon <i>$POPserver</i> </b>";
	}
#if $pop->count is >0, then that is the number of messages in the
#POP account inbox.
else {  print "<img src=$conf::MAIL_IMG valign=middle>&nbsp;&nbsp;";
	print "<b>$MessageCount $conf::messagesininbox (",$pop->Size," $conf::bytestotaltext).</b>\n";
}
print "</td></tr></table>\n";

if ($MessageCount != -1) {	#equivalent to knowing a valid POP account was used...

	#Parse the message headers to output a list of message
	#header info including SUBJECT,FROM,DATE,and TO.
	#each message will have a read & delete button as well
	#and these three elements will be organized in a table
		
	if ($MessageCount > 0) {
		print "<table border=0 cellpadding=2 cellspacing=0 width=90% align=center>";
		print "<tr bgcolor=black><td><b><font color=white>$conf::fromtext</b></td><td><b><font color=white>$conf::subjecttext</b></td><td><b><font color=white>$conf::datetext</b></td><td><b><font color=white>$conf::sizetext</font></b></td><td>&nbsp;</td>";
        &ParseHeaders($pop,$MessageCount,$lastMsg,$password,$pkey,@MessageSize);
		print "</table>";
		}
	
}
#close the POP connection smoothly.
$pop->Close;

$nswmc->stopmenu() if ($conf::noframes);

undef($pop);
undef($MessageCount);
undef(@MessageSize);
undef($nswmc);
undef($pkey);
undef($password);

#send the ending html code (/body and /head tags)
print "</BODY></HTML>";
exit;

#----------------------------------SUBROUTINES-------------------------

# Decode quoted strings (in From: and Subject)

sub DecodeQuoted {
  my $tmp = $_[0];
  my @qtypes=("ISO-\\d\\d\\d\\d-\\d","US-ASCII");
  foreach (@qtypes) {
    if ($tmp =~ m/=\?$_\?.\?/i) {
      $tmp =~ s/=([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $tmp =~ s/=\?$_\?.\?([^\?\=]*)\?=/$1/ig;
      $tmp =~ s/_/ /g;
    }
  }
  return $tmp;
}


#-----------------------------Sub ParseHeaders-----------------------------
#Subroutine to parse the headers on each message to exctract the TO:, FROM:,
# DATE:, and SUBJECT: information.
#--------------------------------------------------------------------------
sub ParseHeaders {
  #loop through the messages in the POP account space
  
  #loop backwards, displaying most recent messages first
  #Also note that only the most recent 100 messages will be displayed from
  #

  my ($pop, $MessageCount, $lastMsg, $password, $pkey, @MessageSize)=@_;

  my $i;
  my $nswmc = new common;

  if ($lastMsg == "") { $lastMsg = $MessageCount };
  
  for ($i=$lastMsg; $i >= 1 && $i> $lastMsg-100; $i--) {
    
    
    #for each message header, provide a FORM button to
    #invoke getmessage.pl and hand that routine the message
    #number. Pass the login,pass,server info again since
    #the web protocol does not provide for continued connections.
    if ( (($i)/2) == int(($i)/2) ) {
      print "<tr>\n";
    } else {
      print "<tr bgcolor=$conf::lightbgcolor>\n";
    }
    
    my $sub = $conf::nosubject;
    my $from = "";	# for sending
    my $from_who = "";	# for display
    my $to = "";
    my $date = "";
    my $replyto = "";
    
    #obtain each header with the head() method in POP3Client.
    
    foreach ($pop->Head($i)){
      #for each line within the message header retrieved, parse
      #the From,To,Date,Subject fields by finding
      #the appropriate strings at the beginning
      #of each line
      if (/^From:/ ){
	$from = $';		#Get string following the succesful match.
	$from = DecodeQuoted($from);
	$from =~ s/"//g;
	$from =~ s/^\s+//;
	$from =~ s/\s+$//;
	$from_who=$from;
	$from_who=~ s/^<//;
	$from_who=~ s/<[^ ]+>//;	# delete e-mail address
	$from_who=~ s/>$//;
	$from_who =~ s/^\s+//;
	$from_who =~ s/\s+$//;
	$from_who = $from if ($from_who eq "");
      }
      elsif (/^To:/) {
	$to = $';
      }
      elsif (/^Subject:/) {
	$sub = $';
	$sub = DecodeQuoted($sub);
	$sub =~ s/^\s*//;
	$sub = $conf::nosubject if (!$sub);
      }
      elsif (/^Date:/) {
	$date = $';
      }
    }
    $date=~ s/.*\,(.*)\+.*/$1/;
    
    $date="<small>$date</small>";
    
    my $size=$MessageSize[$i];
    $size="<small>".int(($size+512)/1024)."k</small>";
    print "<td><a href=\"sendform.pl?loginname=$loginname\&POPserver=$POPserver\&cache=$cache\&password=".$nswmc->cryptit($password,$pkey)."\&to=".URI::Escape::uri_escape($from)."\">$from_who</a></td><td>";
	print "<a href=\"getmsg.pl?id=$i\&loginname=$loginname\&POPserver=$POPserver\&cache=$cache\&password=".$nswmc->cryptit($password,$pkey)."\"><b>$sub</b></a>";
	print "</td><td>$date&nbsp;</td><td>$size</td>";
  
    #for each message header, also provide a FORM button to
    #delete using inbox.pl As above, pass in the needed vars
    #using hidden types.
    print "<td>\n";
	print "<a href=\"inbox.pl?deleteMsg=$i\&loginname=$loginname\&POPserver=$POPserver\&cache=$cache\&password=".$nswmc->cryptit($password,$pkey)."\" onClick=\"return confirm('$conf::deleteconfirmtext');\">";
	print "<img src=\"$conf::PATH_NSWM/trash.gif\" BORDER=0>";
    print "</td></tr>\n";
  }
}

