#! /usr/bin/perl

BEGIN { $APP_PATH=$0; $APP_PATH=~s/(\/*)[^\/]+$/$1/g; push @INC,$APP_PATH; }

# @ ----------------------------------------------------------------------------------------------------------
# @ This code is (c) 1999 Alexandre Aufrere and NikoSoft.
# @ Published under NPL rights, meaning you have the right
# @ to use and modify this code freely, provided it 
# @ remains available and free. Any modified code should be
# @ submitted to Nikopol Software Corp. or Alexandre Aufrere.
# @ This code is protected by the French laws on Copyright.
# @ Please note that there it comes with NO WARRANTY of any kind,
# @ and especially for any damagbe it could cause to your computer
# @ or network.
# @ Using this code means you agree to this license agreement.
# @ Further information at http://www.nikosoft.net
# @ ----------------------------------------------------------------------------------------------------------
# @ 
# @ Project		NS WebMail
# @ 
# @ Filename		sendform.pl
# @ 
# @ Description	build a form for sending mail
# @ 
# @ Version		1.0
# @ 
# @ ----------------------------------------------------------------------------------------------------------

use strict;
use common;
use Socket;
use configwm;
use CGI;
use Mail::POP3Client;
use MIME::Parser;

#obtain the FORM information that has been passed by using
#the param() method of the cgi object.
my $query=new CGI;
my $nswmc=new common;
my $loginname  = $query->param("loginname");
my $password   = $query->param("password");
my $POPserver  = $query->param("POPserver");
my $to         = $query->param("to");
my $subject    = $query->param("subject") || "";
my $msgid      = $query->param("msgid") || "0";
my $cache      = $query->param("cache");


my $body="";
# in case we are replying or forwarding, we retrieve the mail
if ($msgid) {
	#create a POP connection using the POP3client module by
	#creating an object called $pop of type POP3Client. See
	#POP3Client.pm documentation.
	my $pop = new Mail::POP3Client( USER=>$loginname,
		            PASSWORD=> $nswmc->decryptit($password,$query->cookie("PKEY")),
		            HOST=>$POPserver,
		            AUTH_MODE=>$conf::POPauth,
                            PORT=>$conf::POPport
		            );
		
	my $message="";
	foreach ($pop->HeadAndBody($msgid)) {
	  $message.=$_."\n";	
	}

	my $parser = new MIME::Parser;
	$parser->output_dir($conf::temppath);
	$parser->output_prefix("msg$msgid");
	my $entity = $parser->parse_data($message);

	my $attachref=[];
	$body=$nswmc->decodemail($entity,$attachref,0);

	# Put the ">" befor the quoted body
	my @bodylines=split("\n",$body);
	$body="";
	foreach (@bodylines) {
		$body.="> ".$_."\n";
	}
	undef($pop);
}

my $sender = $loginname."\@".$POPserver;
my $addrvrfyed=$sender;
my $from_html;
if ($conf::verifysmtp==1) {
  $addrvrfyed=sendmailvrfy($sender,$conf::SMTPserver);
  if ($addrvrfyed=~ m/^\-[0-9]/) { $addrvrfyed=$sender; }
  $addrvrfyed=~s/^2\.1\.5 //g;    # nuke sendmail 8.10.x vrfy feature
  $from_html=$addrvrfyed;
  $from_html =~ s/</&lt\;/;
  $from_html =~ s/>/&gt\;/;
}

if (defined($conf::masquarade) && $addrvrfyed =~ /$conf::masquarade/) {
	$addrvrfyed=~s/\@([^>^ ]+)/\@$conf::masquarade/;
}

print "Expires: -1d\n";
print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>NSWM</TITLE>";
print "<META HTTP-EQUIV='Pragma' CONTENT='no-cache,no-store'>";
print "</HEAD>";
print "<BODY BGCOLOR='FFFFFF'>\n";

$nswmc->startmenu($loginname,$POPserver,$cache,$password) if ($conf::noframes);

#This calculation determines the width of the text entry boxes.
#The minimum length will either be 36 spaces or 20% larger than the
#largest of the three field entries which are already known.
#Note that depending on how this routine is called, not all
#of the fields are known in advance.
my $width = 40;
$width = ($width>length($sender) ? $width : length($sender));
$width = ($width>length($to)     ? $width : length($to));
$width = ($width>length($subject)? $width : length($subject));
$width *= 1.2;		#fudge factor to avoid visual cramping.
$width = 60 if ($width > 60); #too long else...

print "<FORM METHOD=\"POST\" ACTION=\"".$conf::CGI_PATH_NSWM."send.pl\" enctype=\"multipart/form-data\">\n";
print "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR=\"$conf::lightbgcolor\" width=\"70%\"><TR><TD>\n";
print "";
if ($conf::fake_from) {
	print "$conf::fromtext: </td><td> <INPUT TYPE='text'   NAME='sender'     VALUE='$addrvrfyed'    SIZE=$width>\n";
} else {
	print "$conf::fromtext: </td><td> <INPUT TYPE='hidden'   NAME='sender'     VALUE='$addrvrfyed'> <tt>$from_html</tt>\n";
}
print "</TD><TD WIDTH=100  valign='middle' rowspan=3>&nbsp;\n";
print "</td></tr>\n";
print "<tr><td>";
$to=~ s/\"//g;
print "$conf::totext: </td><td> <INPUT TYPE='text'   NAME='to'         VALUE=\"$to\"        SIZE=$width></td></tr>\n";
print "<tr><td>Cc: </td><td> <INPUT TYPE='text'   NAME='cc'         VALUE=\"\"        SIZE=$width></td></tr>\n";
print "<tr><td>";
$subject=~ s/\"/''/g;
print "$conf::subjecttext: </td><td> <INPUT TYPE='text'   NAME='subject'    VALUE=\"$subject\"   SIZE=$width>\n";
print "</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE=submit value='$conf::sendtext'>&nbsp;";
print "</TD></TR></TABLE>\n";

print "       <INPUT TYPE='hidden' NAME='loginname'  VALUE='$loginname'            >\n";
print "       <INPUT TYPE='hidden' NAME='password'   VALUE='$password'             >\n";
print "       <INPUT TYPE='hidden' NAME='POPserver'  VALUE='$POPserver'            >\n";
print "       <INPUT TYPE='hidden' NAME='cache'      VALUE='$cache'                >\n";

print "$conf::messagetext<br>\n";
print "<textarea rows=14 cols=75 name='message' wrap='virtual'>\n";
print $body;
print "</textarea><br>";
my $attachtext=$conf::attachtext;
$attachtext=~ s/\([^ ]\)//g;
print "$attachtext: <input type=file name=file><br>" if ($conf::sendattach);
print "</FORM>";

$nswmc->stopmenu() if($conf::noframes);

#send the ending html code (/body and /head tags)
print "</BODY></HTML>\n";

undef($query);
undef($msgid);
undef($password);

exit;


#-----------------------------SUBROUTINES------------------------



################################################################
### sendmailvrfy ###############################################
################################################################
sub sendmailvrfy {

my ($addr,$smtp) = @_;

$addr =~ s/[ \t]+/ /g; # pack spaces
$smtp =~ s/^\s+//g; # remove spaces around $smtp
$smtp =~ s/\s+$//g;

my $addrresolved="";

if (!$addr) { return -8; }

my($proto) = (getprotobyname('tcp'))[2];
my($port) = (getservbyname('smtp', 'tcp'))[2];

my($smtpaddr) = ($smtp =~
/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/)
? pack('C4',$1,$2,$3,$4)
: (gethostbyname($smtp))[4];

if (!defined($smtpaddr)) { return -1; }

if (!socket(S, AF_INET, SOCK_STREAM, $proto)) { return -2; }
if (!connect(S, pack('Sna4x8', AF_INET, $port, $smtpaddr))) { return -3; }

my($oldfh) = select(S); $| = 1; select($oldfh);

$_ = <S>; if (/^[45]/) { close S; return -4; }

print S "helo localhost\r\n";
$_ = <S>; if (/^[45]/) { close S; return -5; }

print S "vrfy $addr\r\n";
$_ = <S>;
if (/^[45]/) { close S; return -5; }
else { $addrresolved=$_; }

print S "quit\r\n";
$_ = <S>;

close S;

$addrresolved=~ s/^[0-9]*\s(.*)/$1/;

return $addrresolved;
}

##########

